2 # Desc: Template to report seconds until beginning of next day
4 #==BEGIN Define script parameters==
5 #===BEGIN Declare local script functions===
6 yell
() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
7 die
() { yell
"$*"; exit 111; }
8 try
() { "$@" || die
"cannot $*"; }
10 # Desc: Report seconds until next day.
12 # Output: stdout: integer seconds until next day
13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
14 # Usage: timeUntilNextDay
15 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
16 # Depends: date 8, echo 8, yell, try
18 local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
20 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
21 TIME_NEXT_DAY
="$(date -d "$TIME_CURRENT next day
" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
22 SECONDS_UNTIL_NEXT_DAY
="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
23 if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
25 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
26 returnState
="warning_zero";
27 yell
"WARNING:Reported time until next day exactly zero.";
28 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
29 returnState
="warning_negative";
30 yell
"WARNING:Reported time until next day is negative.";
33 try
echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
35 # Determine function return code
36 if [[ "$returnState" = "true" ]]; then
38 elif [[ "$returnState" = "warning_zero" ]]; then
40 elif [[ "$returnState" = "warning_negative" ]]; then
43 } # Report seconds until next day
44 #===END Declare local script functions===
45 #==END Define script parameters==
48 #==BEGIN sample code==
49 try
echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report
51 if ! myTTL
="$(timeUntilNextDay)"; then yell
"ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
54 # Author: Steven Baltaktei Sandoval